--[[ NOTES

Mapbuilder REALLY needs to be abstracted, possibly move the movement functions too
make a start screen/menu
restrict gameplay to work only OOC. if combat starts, pause game
make game pause, and make pausing the game hide all current pieces (harder to cheat)
		add difficulty setting (ghosty agressiveness, speed)
add score counter, possibly announce high scores/share high scores with guild/friends
add map sharing, possibly through a chat command like /pac sendmap NAME MAPNAME
add settings ui, for difficulty/map management and such 
possible achievements
add game "sessions"
actually use the holding cell, and release ghosties automatically in a game session
add more default maps
add the WIN when all pellets are collected. transition to the next level and increase difficulty
add large pellets
add fruit
add player death and death reset
player death animation
use player lives
give player an extra life every X amount of score. possibly add a statusbar displaying how close to next extra life and/or top score
possibly multiplayer support, where one person is the "host" whose client controls the ghosties and piece movement

ONCE ALL THAT SHIT IS DONE:
i want to add classes from WoW, each with a few class abilities
eg, mage = blink in current direction, frost nova
warlock = fear (WHICH EATS SHIT!!), demon portal thing
druid = roots, bird form (FLY OVER A WALL)
priest = AoE fear & EAT,
warrior = 
paladin = 
rogue = 
shaman = 
hunter = ice trap,
dk = 

multiplayer could be really fun with 2-3 pacman players, 2-3 ghosties players
should ghosty players have special abilities?

======================================
Commands:	
	/pac												show window
	/pac map list										print a list of available maps
	/pac map set [name]									set the map to [name]
	/pac map delete [name]								delete named map, or use "all" to delete all maps
	
	/pac mapbuilder										show mapbuilder window
	/pac mapbuilder clear								clear mapbuilder
	/pac mapbuilder set [length]x[width] [name]			set mapbuilder to dimensions and give name
		
======================================
BUGS



======================================
]]
--[[	CHANGELOG
	A5.0.2
		- added another default map, many more to come later.
		- game speed is now less dependent on client fps. but as a result, graphics may look a tiny bit more choppy
		- slight movement speed adjustments
		- reduced the amount of garbage enemy movement generated by a significant amount
		- added command '/pac agg [0-100]' for testing purposes, to easily adjust the aggressiveness level of enemies
		- ate like 3 donuts
]]
--**************************************************
-- addon globals
local BarTextures = {
["Solid"] = "solid",
["Gradient"] = "gradient",
["Blizzard"] = "Interface\\TargetingFrame\\UI-StatusBar",
["BantoBar"] = "Interface\\Addons\\\MoosePacCraft\\textures\\BantoBar",
["Frost"] = "Interface\\Addons\\\MoosePacCraft\\textures\\Frost",
["Healbot"] = "Interface\\Addons\\\MoosePacCraft\\textures\\Healbot",
["LiteStep"] = "Interface\\Addons\\\MoosePacCraft\\textures\\LiteStep",
["Minimalist"] = "Interface\\Addons\\\MoosePacCraft\\textures\\Minimalist",
["Rocks"] = "Interface\\Addons\\\MoosePacCraft\\textures\\Rocks",
["Runes"] = "Interface\\Addons\\\MoosePacCraft\\textures\\Runes",
["Xeon"] = "Interface\\Addons\\\MoosePacCraft\\textures\\Xeon",
}
local gsub, strfind, strlower, tonumber, tostring, random, floor, ceil, strsub, sqrt, abs, print, tinsert, tremove, pairs = gsub, strfind, strlower, tonumber, tostring, random, floor, ceil, strsub, sqrt, abs, print, tinsert, tremove, pairs
local addonTag = "\124cffffcc00[MoosePacCraft]:\124r"
local PATHS = {}
local Players = {}
local Enemies = {}
local Pellets = {}
local RECYCLABLES = {
	["paths"] = {},
	["players"] = {},
	["enemies"] = {},
	["pellets"] = {},
}
local GameBoardTop,GameBoardBottom,GameBoardLeft,GameBoardRight
local ONUPDATE_SPEED = 1/20		--game loop speed
local PLAYER_ONUPDATE_SPEED = 1/25	--player piece speed
local PLAYER = UnitName("player")
local defaultMap = {		--DEPRECIATED, USE LIBRARY
	--if [x][1] is greater than [x][2], the values will be swapped when the path is created
	--Paths[int(x)] is allowed to hold one or two cell numbers.  if two numbers are specified, the frame will be created with the topleft point paths[x][1] and bottomright paths[x][2]
	--INTEGER KEYS ARE RESERVED FOR CELL COORDINATES.  DO NOT USE THEM FOR MAP PROPERTIES.  USE STRINGS FOR THOSE INSTEAD.
	--cells start with 0 (topleft cell)
	--properties
	["title"] = "default1",
	["columns"] = 15,		-- number of cells per row
	["rows"] = 20,	-- number of cells per column
	["length"] = 20,				--length of the cells' sides (they're always square),
	["playerEntry"] = 247,		--the cell which the player starts on
	["enemyHolding"] = 172,		--the cell (usually a wall) where the enemies are contained before they are released. a special, non-pathable frame is created here to prevent movement, do not place on path
	["enemyEntry"] = 142,			--cell where enemies are released and start moving
	--pathing cells
	16,17,18,19,20,21,22,23,24,25,26,27,28,31,37,43,46,47,48,49,51,52,53,55,56,57,58,61,64,65,66,68,69,70,73,76,78,79,81,82,83,85,86,88,91,93,96,98,101,103,106,108,111,113,116,118,121,122,123,124,126,128,130,131,132,133,136,139,140,141,142,143,144,145,148,151,154,160,163,166,169,175,178,181,182,183,184,190,191,192,193,196,199,200,201,202,203,204,205,208,211,215,217,219,223,226,227,228,229,230,232,234,235,236,237,238,241,243,245,246,247,248,249,251,253,256,258,262,266,268,271,272,273,274,275,276,277,278,279,280,281,282,283,
}
local Ghosty_Speed =  1/22		--default ghosty onupdate speed
local Ghosty_Agressiveness = 25	--determines how often a ghosty will try to move toward the player when it reaches a cross in the path.
local Pac_SlashCmds = {
	[0] = function()		--plain root command was passed
		PacCraft_MapBuilder:Hide()
		if PacCraftGameBoard:IsVisible() then
			PacCraftGameBoard:Hide()
		else
			PacCraftGameBoard:Show()
		end
	end,
	[1] = function(msg)
		--print(addonTag,"command \""..msg.."\" not recognized. Type \"\124cffaaaaaa/mooser commands\124r\" if you need a list of valid commands.")
	end,
}
local MOOSEPACMAN_OPTIONS_DEFAULT = {
	["keybinds"] = {
		["up"] = "W",
		["down"] = "S",
		["left"] = "A",
		["right"] = "D",
		["close"] = "ENTER",
		["boost"] = "LSHIFT",
	},
	["scale"] = 1,
	["sendScoreToGuild"] = true,
}
--**************************************************
--		TESTING/DEBUG FUNCTIONS
function SetGhostySpeed(speed)
	if not speed then return end
	if type(speed) ~= "number" then return end
	Ghosty_Speed = speed
end
function SetGhostyAggressiveness(number)
	if not number then print(addonTag,"You need to specify a number from 1 to 100.") return end
	if type(number) ~= "number" then print(addonTag,"Value must be a \124cffff0000number\124r from 1 to 100. You passed a "..type(number)..".") return end
	number = RoundRealToInt(number)
	if number < 1 or number > 100 then print(addonTag,"You need to specify a number from \124cffff00001 to 100\124r.") return end
	Ghosty_Agressiveness = number
	print(addonTag,"Set Ghosty aggressiveness value to \124cffffcc00"..number.."\124r.")
end
--**************************************************

PacCraftGameBoard:RegisterEvent("ADDON_LOADED")
PacCraftGameBoard:SetScript("OnEvent", function(self,event,...)
	if event == "ADDON_LOADED" then	--SETUP
		self:UnregisterEvent("ADDON_LOADED")
		
		--declare slash command
		SLASH_PAC1 = '/pac'
		if not MOOSEPACMAN_MAPS then MOOSEPACMAN_MAPS = PacCraft_GetDefaultMaps() end
		if not MOOSEPACMAN_OPTIONS then MOOSEPACMAN_OPTIONS = MOOSEPACMAN_OPTIONS_DEFAULT end
		
		for k,v in pairs(MOOSEPACMAN_OPTIONS_DEFAULT) do
			if not MOOSEPACMAN_OPTIONS[k] then MOOSEPACMAN_OPTIONS[k] = v end
		end
		
		self:SetUp()
		PacCraft_MapBuilder:SetUp()

	elseif event == "CHAT_MSG_ADDON" then self:ProcessAddonMessage(...)
	elseif event == "PARTY_LEADER_CHANGED" then
		if IsInRaid() then	--player is in a raid
			inParty = "RAID"
			return
		elseif GetNumSubgroupMembers() > 0 then
			inParty = "PARTY"
			return
		else
			inParty = false
		end
	end

end)

--slash command handler
function SlashCmdList.PAC(msg)
	msg = strlower(msg)
	if msg == "" then msg = 0 end
	
	if strfind(msg,"map") then	--a map command was sent
		local map = PacCraft_MapBuilder
		if msg == "mapbuilder" then
			PacCraftGameBoard:Hide()
			map:Show()
			map:ReDrawButtons(true)
			return
		end
		if strfind(msg,"mapbuilder set %d+x%d+%s+.+") then
			PacCraftGameBoard:Hide()
			map:Show()
			local _,columns,_,rows,_,title = string.match(msg,"(%D+)(%d+)(x)(%d+)(%s+)(.+)")
			if not map.paths.length then map.paths.length = 20 end
			map.paths.columns = tonumber(columns)
			map.paths.rows = tonumber(rows)
			map.paths.title = title
			map:ReDrawButtons(true)
			return
		end
		if strfind(msg,"mapbuilder clear") then
			PacCraftGameBoard:Hide()
			map:Show()
			map.paths.columns = 10
			map.paths.rows = 10
			map.paths.length = 20
			self:ReDrawButtons(true)
			return
		end
		if strfind(msg,"map set .+") then
			PacCraftGameBoard:Show()
			map:Hide()
			local _,name = string.match(msg,"(map set )(.+)")
			if MOOSEPACMAN_MAPS[name] then
				--set current map to one passed
				PacCraftGameBoard:SetPaths(MOOSEPACMAN_MAPS[name])
			else
				--map doens't exist, print error
				print(addonTag,"Map doesn't exist. Try \124cffaaaaaa\"/pac map list\"\124r to list all maps in database.")
			end
			return
		end
		if strfind(msg,"map list") then
			--print list of maps
			for k,v in pairs(MOOSEPACMAN_MAPS) do
				print(addonTag,"map- \""..k.."\"")
			end
			return
		end
		if strfind(msg,"map delete .+") then
			--delete a map from the database
			local _,name = string.match(msg,"(map delete )(.+)")
			if name == "all" then
				wipe(MOOSEPACMAN_MAPS)
				print(addonTag,"All maps deleted.")
			elseif MOOSEPACMAN_MAPS[name] ~= nil then
				MOOSEPACMAN_MAPS[name] = nil
				print(addonTag,"map- \""..name.."\" deleted.")
			else
				print(addonTag,"Can't delete map- \""..name.."\"; it doesn't exist.")
			end
			return
		end
		
		
		
		return
	end

	if strfind(msg,"agg") then
		
		local _,number = string.match(msg,"(agg )(%d+)")
		if type(tonumber(number)) ~= "number" then return end
		number = tonumber(number)
		SetGhostyAggressiveness(number)
		
	end
	
	--UPDATE
	if Pac_SlashCmds[msg] ~= nil then
		pcall(Pac_SlashCmds[msg])
	else
		pcall(Pac_SlashCmds[1],msg)
	end
end

function PacCraft_MapBuilder:ReDrawButtons(reset)
	if not self.paths.length then self.paths.length = 20 end
	if not self.paths.columns or not self.paths.rows then return end
	
	for x=1,#self.buttons do
		self.buttons[x]:Hide()
	end
	
	self:SetHeight(self.paths.length * self.paths.rows)
	self:SetWidth(self.paths.length * self.paths.columns)
	
	for x=0,((self.paths.columns * self.paths.rows)-1) do
		if not _G["PacMapBuilderButton"..x] then
			CreateFrame("CheckButton","PacMapBuilderButton"..x,self,"PacCraft_MapBuilderButtonTemplate")
			tinsert(self.buttons,_G["PacMapBuilderButton"..x])
		end
		_G["PacMapBuilderButton"..x]:ClearAllPoints()
		_G["PacMapBuilderButton"..x]:SetWidth(self.paths.length)
		_G["PacMapBuilderButton"..x]:SetHeight(self.paths.length)	
		local topLeftx, topLefty =  self.paths.length * (x % self.paths.columns), self.paths.length * (floor(x / self.paths.columns))
		_G["PacMapBuilderButton"..x]:SetPoint("TOPLEFT",self,"TOPLEFT",topLeftx,-topLefty)
		_G["PacMapBuilderButton"..x]:Show()
	end
end

function PacCraft_MapBuilder:SavePath()	--saves a map constructed in the map builder
	if not self.paths.length then self.paths.length = 20 end
	if not self.paths.columns or not self.paths.rows then return nil end
	
	local MAP = {
		["length"] = self.paths.length,
		["columns"] = self.paths.columns,
		["rows"] = self.paths.rows,
		["playerEntry"] = self.paths.playerEntry,
		["enemyHolding"] = self.paths.enemyHolding,
		["enemyEntry"] = self.paths.enemyEntry,
		["title"] = self.paths.title,
	}
	
	for x=1,#self.buttons do
		if self.buttons[x]:GetChecked() then
			local cell = gsub(self.buttons[x]:GetName(),"PacMapBuilderButton","")
			tinsert(MAP,tonumber(cell))
		end
	end
	
	if not MAP.playerEntry then MAP.playerEntry = MAP[1] end
	if not MAP.enemyHolding then MAP.enemyHolding = 500 end
	if not MAP.enemyEntry then MAP.enemyEntry = MAP[5] end
	if not MAP.title then MAP.title = "untitled"..(time()) end
	
	for k,v in pairs(MAP) do
		if k == "playerEntry" or k == "enemyEntry" or k == "enemyHolding" then
			if not tblContains(MAP,v) then
				tinsert(MAP,v)
			end
		end
	end
	
	if not MOOSEPACMAN_MAPS[MAP.title] then
		MOOSEPACMAN_MAPS[MAP.title] = MAP
		print(addonTag,"Map \""..MAP.title.."\" saved.")
	else
		print(addonTag,"Map couldn't be saved as \""..MAP.title.."\"; Map with that name already exists.")
		while MOOSEPACMAN_MAPS[MAP.title] do
			MAP.title = "untitled"..(time())
		end
		print(addonTag,"Saving as \""..MAP.title.."\" instead.")
		MOOSEPACMAN_MAPS[MAP.title] = MAP
	end
	
end

function PacCraft_MapBuilder:SetUp()

	self.On_Off = true
	self.TimeSinceLastUpdate = 0
	self.ONUPDATE_SPEED = .05
	self:SetScript("OnUpdate",PacCraft_MapBuilder_OnUpdate)
	self:SetScript("OnKeyDown", function(self, key)
		--print(key)
		if key == "ENTER" then
			print(addonTag,key,"key pressed. Hiding map builder...")
			self:Hide()
			self.mouseIsDown = false
			return
		end
		if key == "S" then
			print(addonTag,"Saving map...")
			self:SavePath()
			return
		end
		if key == "1" then
			if self.mouseIsDown then return end
			local button = GetMouseFocus()
			if not button or not tblContains(self.buttons,button) then return end
			local cell = gsub(button:GetName(),"PacMapBuilderButton","")
			if tonumber(cell) ~= self.paths.playerEntry and self.paths.playerEntry then	--a position already exists
				_G["PacMapBuilderButton"..self.paths.playerEntry]:SetChecked(1)
				_G["PacMapBuilderButton"..self.paths.playerEntry].texture:SetTexture(1,1,1,.5)
			end
			button.texture:SetTexture("Interface\\AddOns\\MoosePacCraft\\pacsprites\\pacman_right_closed")
			self.paths.playerEntry = tonumber(cell)
			print(addonTag,"Player starting position moved to cell "..cell..".")
			
			return
		end
		if key == "2" then
			if self.mouseIsDown then return end
			local button = GetMouseFocus()
			if not button or not tblContains(self.buttons,button) then return end
			local cell = gsub(button:GetName(),"PacMapBuilderButton","")
			if tonumber(cell) ~= self.paths.enemyEntry and self.paths.enemyEntry then	--a position already exists
				_G["PacMapBuilderButton"..self.paths.enemyEntry]:SetChecked(1)
				_G["PacMapBuilderButton"..self.paths.enemyEntry].texture:SetTexture(1,1,1,.5)
			end
			button.texture:SetTexture("Interface\\AddOns\\MoosePacCraft\\pacsprites\\ghost_teal_right1")
			self.paths.enemyEntry = tonumber(cell)
			print(addonTag,"Enemy starting position moved to cell "..cell..".")
			
			return
		end
		if key == "3" then
			if self.mouseIsDown then return end
			local button = GetMouseFocus()
			if not button or not tblContains(self.buttons,button) then return end
			local cell = gsub(button:GetName(),"PacMapBuilderButton","")
			if tonumber(cell) ~= self.paths.enemyHolding and self.paths.enemyHolding then	--a position already exists
				_G["PacMapBuilderButton"..self.paths.enemyHolding]:SetChecked(false)
				_G["PacMapBuilderButton"..self.paths.enemyHolding].texture:SetTexture(0,0,0,.65)
			end
			button.texture:SetTexture(1,0,0,1)
			self.paths.enemyHolding = tonumber(cell)
			print(addonTag,"Enemy holding position placed at cell "..cell..".")
			
			return
		end
	end)
	
	--self:SetScript("OnKeyUp", function(self, key) end)
end

function PacCraft_MapBuilder_OnUpdate(self,elapsed)
	self.TimeSinceLastUpdate = self.TimeSinceLastUpdate + elapsed
	while self.TimeSinceLastUpdate >= self.ONUPDATE_SPEED do
		self.TimeSinceLastUpdate = self.TimeSinceLastUpdate - self.ONUPDATE_SPEED
		if not self.mouseIsDown then return end
		local button = GetMouseFocus()
		
		if not button or not tblContains(self.buttons,button) then return end
		--print(button:GetName())
		--at this point, left mouse button is being held down over a map builder button
		if button:GetChecked() ~= self.On_Off then
			button:SetChecked(self.On_Off)	--doesn't matter if we use SetChecked() or Click(), neither will run the OnClick handler
			if button:GetChecked() then button.texture:SetTexture(1,1,1,.5) else button.texture:SetTexture(0,0,0,.65) end
			local cell = gsub(button:GetName(),"PacMapBuilderButton","")
			if tonumber(cell) == self.playerEntry then
				button.texture:SetTexture("Interface\\AddOns\\MoosePacCraft\\pacsprites\\pacman_right_closed")
			elseif cell == self.enemyEntry then
				button.texture:SetTexture("Interface\\AddOns\\MoosePacCraft\\pacsprites\\pacman_right_closed")
			elseif cell == self.enemyHolding then
				button.texture:SetTexture(1,0,0,1)
			end
		end
	end
end

function PacCraftGameBoard:ResetMap()
	for k,v in pairs(PATHS) do	--path positions will be reassigned when the map is next built
		v.frame:Hide()
		tinsert(RECYCLABLES.paths,v.frame)
	end
	for k,v in pairs(Pellets) do		-- pellet positions will be assigned with paths
		v:Hide()
		tinsert(RECYCLABLES.pellets,v)
	end
	for k,v in pairs(Players) do
		v.frame:Hide()
		tinsert(RECYCLABLES.players,v.frame)
	end
	for k,v in pairs(Enemies) do
		v.frame:Hide()
		tinsert(RECYCLABLES.enemies,v.frame)
	end
	wipe(PATHS)
	wipe(Pellets)
	wipe(Players)
	wipe(Enemies)
end

function PacCraftGameBoard:SetUp()
	
	RegisterAddonMessagePrefix("$pac")
	self:RegisterEvent("CHAT_MSG_ADDON")
	self:RegisterEvent("PARTY_LEADER_CHANGED")
	
	self.TimeSinceLastUpdate = 0
	self:SetScript("OnUpdate",PacCraftGameBoard_OnUpdate)
	self:SetScript("OnKeyDown", function(self, key)
		--print(key)
		if key == "ENTER" then
			print(addonTag,key,"key down. Stopping Game...")
			self:Hide()
			--pause game
			Players[PLAYER].direction = "stop"
			return
		end
		if key == "C" then
			Players[PLAYER].frame:SetPoint("TOPLEFT",self,"TOPLEFT",20,-20)
			return
		end
		if key == "V" then
			CreateEnemyObject(tostring(time()),nil)
			return
		end
		if key == "LSHIFT" then
			--print("SPEED BOOST")
			Players[PLAYER].updateSpeed = PLAYER_ONUPDATE_SPEED / 2
			return
		end
		if key == "W" then
			Players[PLAYER].direction = "up"
			PacCraftGameBoard:SetScript("OnUpdate",PacCraftGameBoard_OnUpdate)
			return
		elseif key == "S" then
			Players[PLAYER].direction = "down"
			PacCraftGameBoard:SetScript("OnUpdate",PacCraftGameBoard_OnUpdate)
			return
		elseif key == "A" then
			Players[PLAYER].direction = "left"
			PacCraftGameBoard:SetScript("OnUpdate",PacCraftGameBoard_OnUpdate)
			return
		elseif key == "D" then
			Players[PLAYER].direction = "right"
			PacCraftGameBoard:SetScript("OnUpdate",PacCraftGameBoard_OnUpdate)
			return
		end
	end)
	
	self:SetScript("OnKeyUp", function(self, key)
		if key == "LSHIFT" then
			Players[PLAYER].updateSpeed = PLAYER_ONUPDATE_SPEED
			return
		end
		if key == "B" then
			for k,v in pairs(Enemies) do
				v.frame:Hide()
			end
			return
		end
		if key == "W" and Players[PLAYER].direction == "up" then
			Players[PLAYER].direction = "stop"
			return
		elseif key == "S" and Players[PLAYER].direction == "down" then
			Players[PLAYER].direction = "stop"
			return
		elseif key == "A" and Players[PLAYER].direction == "left" then
			Players[PLAYER].direction = "stop"
			return
		elseif key == "D" and Players[PLAYER].direction == "right" then
			Players[PLAYER].direction = "stop"
			return
		end
	end)
	
	local maplist = {}
	for k,v in pairs(MOOSEPACMAN_MAPS) do
		if k ~= nil then
			tinsert(maplist,k)
		end
	end
	if #maplist == 0 then	--repopulate maplist with default maps
		MOOSEPACMAN_MAPS = PacCraft_GetDefaultMaps()
		for k,v in pairs(MOOSEPACMAN_MAPS) do
			tinsert(maplist,k)
		end
	end
	
	self:SetPaths(MOOSEPACMAN_MAPS[maplist[random(1,#maplist)]])
end

--[[	MOVEMENT AND CHECKING HANDLERS ]]
local PlayerDirectionHandlers = {	--returns bool: whether or not the next step for player piece is legal
	--path x,y data is rounded, other dimensions are not
	["up"] = function(piece)
		--piece.cell = tostring(GetPieceCell(piece))
		local path = PATHS[piece.cell]
		if not path then return false end
		if (abs(RoundRealToInt(piece.CenterX) - path.x) <= 5) and ((piece.CenterY >= path.bottom and RoundRealToInt(piece.CenterY) < path.y) or path.UP) then
			return true
		else return false end
	end,
	["down"] = function(piece)
		--piece.cell = tostring(GetPieceCell(piece))
		local path = PATHS[piece.cell]
		if not path then return false end
		if (abs(RoundRealToInt(piece.CenterX) - path.x) <= 5) and ((piece.CenterY <= path.top and RoundRealToInt(piece.CenterY) > path.y) or path.DOWN) then
			return true
		else return false end
	end,
	["left"] = function(piece)
		--piece.cell = tostring(GetPieceCell(piece))
		local path = PATHS[piece.cell]
		if not path then return false end
		if (abs(RoundRealToInt(piece.CenterY) - path.y) <= 5) and ((piece.CenterX <= path.right and RoundRealToInt(piece.CenterX) > path.x) or path.LEFT) then
			return true
		else return false end
	end,
	["right"] = function(piece)
		--piece.cell = tostring(GetPieceCell(piece))
		local path = PATHS[piece.cell]
		if not path then return false end
		if (abs(RoundRealToInt(piece.CenterY) - path.y) <= 5) and ((piece.CenterX >= path.left and RoundRealToInt(piece.CenterX) < path.x) or path.RIGHT) then
			return true
		else return false end
	end,
}

local EnemyDirectionHandlers = {
	--path x,y data is already rounded so don't call RoundRealToInt() on them, other dimensions are not
	["up"] = function(piece)
		if not PATHS[piece.cell] then return false end
		if (RoundRealToInt(piece.CenterX) == PATHS[piece.cell].x) and ((piece.CenterY >= PATHS[piece.cell].bottom and RoundRealToInt(piece.CenterY) < PATHS[piece.cell].y) or PATHS[piece.cell].UP) then
			return true
		else return false end
	end,
	["down"] = function(piece)
		if not PATHS[piece.cell] then return false end
		if (RoundRealToInt(piece.CenterX) == PATHS[piece.cell].x) and ((piece.CenterY <= PATHS[piece.cell].top and RoundRealToInt(piece.CenterY) > PATHS[piece.cell].y) or PATHS[piece.cell].DOWN) then
			return true
		else return false end
	end,
	["left"] = function(piece)
		if not PATHS[piece.cell] then return false end
		if (RoundRealToInt(piece.CenterY) == PATHS[piece.cell].y) and ((piece.CenterX <= PATHS[piece.cell].right and RoundRealToInt(piece.CenterX) > PATHS[piece.cell].x) or PATHS[piece.cell].LEFT) then
			return true
		else return false end
	end,
	["right"] = function(piece)
		if not PATHS[piece.cell] then return false end
		if (RoundRealToInt(piece.CenterY) == PATHS[piece.cell].y) and ((piece.CenterX >= PATHS[piece.cell].left and RoundRealToInt(piece.CenterX) < PATHS[piece.cell].x) or PATHS[piece.cell].RIGHT) then
			return true
		else return false end
	end,
}

local PieceMovementHandlers = {		--no return; moves a game piece a step in its direction.  DOES NOT CHECK if its a legal move
	["up"] = function(piece)
		piece.yOffset = piece.yOffset + (PacCraftGameBoard.paths.length / 10)
		piece.frame:SetPoint("TOPLEFT",PacCraftGameBoard,"TOPLEFT",piece.xOffset,piece.yOffset)
		--piece.CenterX, piece.CenterY = piece.frame:GetCenter()
		piece.cell = GetPieceCell(piece)
		--print(piece.frame.NAME,piece.cell)
	end,
	["down"] = function(piece)
		piece.yOffset = piece.yOffset - (PacCraftGameBoard.paths.length / 10)
		piece.frame:SetPoint("TOPLEFT",PacCraftGameBoard,"TOPLEFT",piece.xOffset,piece.yOffset)
		--piece.CenterX, piece.CenterY = piece.frame:GetCenter()
		piece.cell = GetPieceCell(piece)
		--print(piece.frame.NAME,piece.cell)
	end,
	["left"] = function(piece)
		piece.xOffset = piece.xOffset - (PacCraftGameBoard.paths.length / 10)
		piece.frame:SetPoint("TOPLEFT",PacCraftGameBoard,"TOPLEFT",piece.xOffset,piece.yOffset)
		--piece.CenterX, piece.CenterY = piece.frame:GetCenter()
		piece.cell = GetPieceCell(piece)
		--print(piece.frame.NAME,piece.cell)
	end,
	["right"] = function(piece)
		piece.xOffset = piece.xOffset + (PacCraftGameBoard.paths.length / 10)
		piece.frame:SetPoint("TOPLEFT",PacCraftGameBoard,"TOPLEFT",piece.xOffset,piece.yOffset)
		--piece.CenterX, piece.CenterY = piece.frame:GetCenter()
		piece.cell = GetPieceCell(piece)
		--print(piece.frame.NAME,piece.cell)
	end,
}

local EnemyMovementHandlers = {		--no return; moves enemy piece a step in its direction.  DOES NOT CHECK if its a legal move
	["up"] = function(name)
		Enemies[name].yOffset = Enemies[name].yOffset + (PacCraftGameBoard.paths.length / 10)		--10 may seem arbitrary, it translates to X (10) steps to move through one cell to the next
		Enemies[name].frame:SetPoint("TOPLEFT",PacCraftGameBoard,"TOPLEFT",Enemies[name].xOffset,Enemies[name].yOffset)
		Enemies[name].cell = GetEnemyPieceCell(name)
	end,
	["down"] = function(name)
		Enemies[name].yOffset = Enemies[name].yOffset - (PacCraftGameBoard.paths.length / 10)
		Enemies[name].frame:SetPoint("TOPLEFT",PacCraftGameBoard,"TOPLEFT",Enemies[name].xOffset,Enemies[name].yOffset)
		Enemies[name].cell = GetEnemyPieceCell(name)
	end,
	["left"] = function(name)
		Enemies[name].xOffset = Enemies[name].xOffset - (PacCraftGameBoard.paths.length / 10)
		Enemies[name].frame:SetPoint("TOPLEFT",PacCraftGameBoard,"TOPLEFT",Enemies[name].xOffset,Enemies[name].yOffset)
		Enemies[name].cell = GetEnemyPieceCell(name)
	end,
	["right"] = function(name)
		Enemies[name].xOffset = Enemies[name].xOffset + (PacCraftGameBoard.paths.length / 10)
		Enemies[name].frame:SetPoint("TOPLEFT",PacCraftGameBoard,"TOPLEFT",Enemies[name].xOffset,Enemies[name].yOffset)
		Enemies[name].cell = GetEnemyPieceCell(name)
	end,
}

function CreatePlayerObject(name,color)	--parent frame for the object,	name of player the piece is for,	optional coloring (nyi)
	if not Players[name] then
		Players[name] = {}
		Players[name].isDead = false
		Players[name].isBeingRecycled = false
		
		Players[name].frame = CreateFrame("frame","PacCraftPlayer_"..name,PacCraftGameBoard,"PacCraft_PlayerTemplate")
		Players[name].frame.NAME = name
		Players[name].frame:SetFrameLevel(2)
		
		--texture stuff
		Players[name].texture = _G[Players[name].frame:GetName().."_BGTexture"]
		Players[name].texture:Show()
		Players[name].textureData = {}
		Players[name].textureData.sets = {
			["right"] = {"Interface\\AddOns\\MoosePacCraft\\pacsprites\\pacman_right_closed","Interface\\AddOns\\MoosePacCraft\\pacsprites\\pacman_right_open",},
			["left"] = {"Interface\\AddOns\\MoosePacCraft\\pacsprites\\pacman_left_closed","Interface\\AddOns\\MoosePacCraft\\pacsprites\\pacman_left_open",},
			["up"] = {"Interface\\AddOns\\MoosePacCraft\\pacsprites\\pacman_up_closed","Interface\\AddOns\\MoosePacCraft\\pacsprites\\pacman_up_open",},
			["down"] = {"Interface\\AddOns\\MoosePacCraft\\pacsprites\\pacman_down_closed","Interface\\AddOns\\MoosePacCraft\\pacsprites\\pacman_down_open",},
		}
		Players[name].textureData.index = 1
		Players[name].textureData.updateSpeed = PLAYER_ONUPDATE_SPEED * 4
		Players[name].textureData.tslu = 1
		Players[name].textureData.direction = "right"
	
		--onupdate stuff
		Players[name].tslu = 0		--"time since last update"
		Players[name].updateSpeed = PLAYER_ONUPDATE_SPEED
		Players[name].frame:SetScript("OnUpdate",function(self,elapsed)	--movement
			local P = Players[self.NAME]
			P.tslu,P.textureData.tslu = (P.tslu + elapsed),(P.textureData.tslu + elapsed)
			if P.tslu >= P.updateSpeed then	--piece movement
				P.tslu = P.tslu - P.updateSpeed
				if P.direction ~= "stop" then
					if PlayerDirectionHandlers[P.direction] then			--if function exists
						if PlayerDirectionHandlers[P.direction](P) then		--checks if next move is legal
							PieceMovementHandlers[P.direction](P)	--moves the piece a step
							if P.textureData.direction ~= P.direction and P.direction ~= "stop" then
								P.textureData.direction = P.direction
							end
						end
					end
				end
			end
			if P.textureData.tslu >= P.textureData.updateSpeed then	--texture animation
				P.textureData.tslu = P.textureData.tslu - P.textureData.updateSpeed
				if P.textureData.index >= #P.textureData.sets[P.textureData.direction] then P.textureData.index = 0 end
				P.textureData.index = P.textureData.index + 1
				P.texture:SetTexture(P.textureData.sets[P.textureData.direction][P.textureData.index])
			end
		end)
	end
	
	Players[name].direction = "stop"
	Players[name].tslu = 0
	Players[name].frame:Show()
	Players[name].frame:SetWidth(PacCraftGameBoard.paths.length)
	Players[name].frame:SetHeight(PacCraftGameBoard.paths.length)
	local framestartx,framestarty = PacCraftGameBoard:CellToCoords(PacCraftGameBoard.paths.playerEntry)
	Players[name].frame:SetPoint("TOPLEFT",PacCraftGameBoard,"TOPLEFT",framestartx,framestarty)
	Players[name].xOffset = Players[name].frame:GetLeft() - PacCraftGameBoard:GetLeft()
	Players[name].yOffset = Players[name].frame:GetTop() - PacCraftGameBoard:GetTop()
	Players[name].cell = GetPieceCell(Players[name])
	Players[name].lives = 3
	
end

function MoveEnemyPiece(Enemy)
	
	if Enemy.direction ~= "stop" then
		
		--IF NOT AT THE POINT WHERE WE CAN TURN, CONTINUE ON THE PATH AND RETURN
		--ELSE DO THIS SHIT  v  v  v
		if RoundRealToInt(Enemy.CenterX) ~= (PATHS[Enemy.cell].x)or RoundRealToInt(Enemy.CenterY) ~= (PATHS[Enemy.cell].y) then	--NOT ALIGNED WITH CELL CENTERS
			--CONTINUE ON PATH
			PieceMovementHandlers[Enemy.direction](Enemy)
			return
		end
		
		
		-- MAKE TABLE DATA WRITE OVER EXISTING DATA INSTEAD OF CREATING A WHOLE NEW TABLE
		if Enemy.direction == "up" then	--directions are hard-coded like this to prevent 180s
			Enemy.viableDirs = {"right","left","up",}
		elseif Enemy.direction == "down" then
			Enemy.viableDirs = {"right","left","down",}
		elseif Enemy.direction == "left" then
			Enemy.viableDirs = {"left","down","up",}
		elseif Enemy.direction == "right" then
			Enemy.viableDirs = {"right","down","up",}
		end
		
		for count=1,4 do
			if Enemy.viableDirs[5 - count] then	--go backwards and use tremove()
				if not EnemyDirectionHandlers[Enemy.viableDirs[5 - count] ](Enemy) then
					tremove(Enemy.viableDirs,5 - count)
				end
			end
		end

		--print(#Enemy.viableDirs,Enemy.viableDirs[1],Enemy.viableDirs[2],Enemy.viableDirs[3],Enemy.viableDirs[4])
		
		if #Enemy.viableDirs == 0 then		--it's necessary to turn 180
			--print("PACCRAFT: "..name.." is stuck. turning a 180.")
			if Enemy.direction == "up" then Enemy.direction = "down"
			elseif Enemy.direction == "down" then Enemy.direction = "up"
			elseif Enemy.direction == "left" then Enemy.direction = "right"
			elseif Enemy.direction == "right" then Enemy.direction = "left"
			end
			PieceMovementHandlers[Enemy.direction](Enemy)
			return
		end
		
		if #Enemy.viableDirs > 1 then
			if random(1,100) < Ghosty_Agressiveness then	--percent chance to move towards the player at an intersection
				--local distX, distY = (Enemy.CenterX - Players[PLAYER].CenterX), (Enemy.CenterY - Players[PLAYER].CenterY)
				local distX, distY =
					(Enemy.cell % PacCraftGameBoard.paths.columns) - (Players[PLAYER].cell % PacCraftGameBoard.paths.columns),
					floor(Enemy.cell / PacCraftGameBoard.paths.columns) - floor(Players[PLAYER].cell / PacCraftGameBoard.paths.columns)
	
				--quad 1
				if distX <= 0 and distY >= 0 then
					local randDirs = {}
					if tblContains(Enemy.viableDirs,"right") then tinsert(randDirs,"right") end
					if tblContains(Enemy.viableDirs,"up") then tinsert(randDirs,"up") end
					if #randDirs > 0 then
						Enemy.direction = randDirs[random(1,#randDirs)]
						PieceMovementHandlers[Enemy.direction](Enemy)
						return
					end
				--quad 2
				elseif distX >= 0 and distY >= 0 then
					local randDirs = {}
					if tblContains(Enemy.viableDirs,"left") then tinsert(randDirs,"left") end
					if tblContains(Enemy.viableDirs,"up") then tinsert(randDirs,"up") end
					if #randDirs > 0 then
						Enemy.direction = randDirs[random(1,#randDirs)]
						PieceMovementHandlers[Enemy.direction](Enemy)
						return
					end
				--quad 3
				elseif distX >= 0 and distY <= 0 then
					local randDirs = {}
					if tblContains(Enemy.viableDirs,"left") then tinsert(randDirs,"left") end
					if tblContains(Enemy.viableDirs,"down") then tinsert(randDirs,"down") end
					if #randDirs > 0 then
						Enemy.direction = randDirs[random(1,#randDirs)]
						PieceMovementHandlers[Enemy.direction](Enemy)
						return
					end
				--quad 4
				elseif distX <= 0 and distY <= 0 then
					local randDirs = {}
					if tblContains(Enemy.viableDirs,"right") then tinsert(randDirs,"right") end
					if tblContains(Enemy.viableDirs,"down") then tinsert(randDirs,"down") end
					if #randDirs > 0 then
						Enemy.direction = randDirs[random(1,#randDirs)]
						PieceMovementHandlers[Enemy.direction](Enemy)
						return
					end
				end
				
				--move at random if none of the above conditions are met
				Enemy.direction = Enemy.viableDirs[random(1,#Enemy.viableDirs)]
				PieceMovementHandlers[Enemy.direction](Enemy)
				return
			
			else	-- random direction
				Enemy.direction = Enemy.viableDirs[random(1,#Enemy.viableDirs)]
				PieceMovementHandlers[Enemy.direction](Enemy)
				return
			end
		else	--there's only 1 direction available
			Enemy.direction = Enemy.viableDirs[1]
			PieceMovementHandlers[Enemy.direction](Enemy)
			return
		end
	end
end

function CreateEnemyObject(name,color)	--	name of player the piece is for,	optional coloring (nyi)
	local E
	if not Enemies[name] then
		Enemies[name] = {}
		E = Enemies[name]
		E.isDead = false
		E.isBeingRecycled = false
		
		E.frame = CreateFrame("frame","PacCraftEnemy_"..name,PacCraftGameBoard,"PacCraft_PlayerTemplate")
		E.frame.NAME = name
		E.frame:SetWidth(PacCraftGameBoard.paths.length)
		E.frame:SetHeight(PacCraftGameBoard.paths.length)
		E.frame:SetFrameLevel(PacCraftGameBoard:GetFrameLevel() + 2)
		
		--texture things
		E.texture = _G[E.frame:GetName().."_BGTexture"]
		E.textureData = {
			["sets"] = GetRandomGhostyTextureSet(),
			["index"] = 1,
			["updateSpeed"] = Ghosty_Speed * 4,
			["tslu"] = 1,
			["direction"] = "right",
		}
		
		--onupdate stuff
		E.tslu = 0
		--E.updateSpeed = .04	--USE Ghosty_Speed INSTEAD
		E.frame:SetScript("OnUpdate",function(self,elapsed)	--movement
			E.tslu, E.textureData.tslu = (E.tslu + elapsed), (E.textureData.tslu + elapsed)
			if E.tslu >= Ghosty_Speed then
				E.tslu = E.tslu - Ghosty_Speed
				--MoveEnemyPiece(E)	--movement

				--TEXTURE UPDATE (placed here so we can call returns in the movement scripts below)
				if E.textureData.tslu >= E.textureData.updateSpeed then
					if E.textureData.direction ~= E.direction then E.textureData.direction = E.direction end
					E.textureData.tslu = E.textureData.tslu - E.textureData.updateSpeed
					if E.textureData.index >= #E.textureData.sets[E.textureData.direction] then E.textureData.index = 0 end
					E.textureData.index = E.textureData.index + 1
					E.texture:SetTexture(E.textureData.sets[E.textureData.direction][E.textureData.index])
				end
				
				--MOVEMENT HANDLING
				if E.direction == "stop" then return end

				--IF NOT ALIGNED ON A CELL CENTER, CONTINUE ON PATH
				if RoundRealToInt(E.CenterX) ~= (PATHS[E.cell].x)or RoundRealToInt(E.CenterY) ~= (PATHS[E.cell].y) then
					EnemyMovementHandlers[E.direction](name)
					return
				end

				-- hard-coded to prevent allowing a 180 degree turn
				E.viableDirs.right = ((E.CenterX >= PATHS[E.cell].left and RoundRealToInt(E.CenterX) < PATHS[E.cell].x) or PATHS[E.cell].RIGHT) and E.direction ~= "left"
				E.viableDirs.left = ((E.CenterX <= PATHS[E.cell].right and RoundRealToInt(E.CenterX) > PATHS[E.cell].x) or PATHS[E.cell].LEFT) and E.direction ~= "right"			
				E.viableDirs.up = ((E.CenterY >= PATHS[E.cell].bottom and RoundRealToInt(E.CenterY) < PATHS[E.cell].y) or PATHS[E.cell].UP) and E.direction ~= "down"
				E.viableDirs.down = ((E.CenterY <= PATHS[E.cell].top and RoundRealToInt(E.CenterY) > PATHS[E.cell].y) or PATHS[E.cell].DOWN) and E.direction ~= "up"
				
				local numViableDirs = 0
				for _,v in pairs(E.viableDirs) do
					if v then numViableDirs = numViableDirs + 1 end
				end

				--it's necessary to turn 180
				if numViableDirs == 0 then
					--print("PACCRAFT: "..self.NAME.." is stuck. turning a 180.")	--debug
					if E.direction == "up" then E.direction = "down"
					elseif E.direction == "down" then E.direction = "up"
					elseif E.direction == "left" then E.direction = "right"
					elseif E.direction == "right" then E.direction = "left"
					end
					EnemyMovementHandlers[E.direction](name)
					return
				end
				
				if numViableDirs == 1 then	--this is up here because it will be the case most of the time	
					for k,v in pairs(E.viableDirs) do
						if v then	--there will always be at least 1 true
							E.direction = k
							EnemyMovementHandlers[E.direction](name)
							return
						end
					end
					return		--should never reach this, but just in case
				end

				local randDirs = {}
				if random(1,100) < Ghosty_Agressiveness then	--percent chance to move towards the player
					--number of cells between enemy and player;  negative x = player is to the right of enemy, negative y = player is above enemy
					local distX, distY =
						(E.cell % PacCraftGameBoard.paths.columns) - (Players[PLAYER].cell % PacCraftGameBoard.paths.columns),
						floor(E.cell / PacCraftGameBoard.paths.columns) - floor(Players[PLAYER].cell / PacCraftGameBoard.paths.columns)
					
					--this may use tables but it is easier than hard-coding directions
					--if player is in quad 1 (+x,+y) relative to enemy
					if distX <= 0 and distY >= 0 then
						if E.viableDirs.right then tinsert(randDirs,"right") end
						if E.viableDirs.up then tinsert(randDirs,"up") end
						if #randDirs > 0 then
							E.direction = randDirs[random(1,#randDirs)]
							EnemyMovementHandlers[E.direction](name)
							return
						end
					--quad 2
					elseif distX >= 0 and distY >= 0 then
						if E.viableDirs.left then tinsert(randDirs,"left") end
						if E.viableDirs.up then tinsert(randDirs,"up") end
						if #randDirs > 0 then
							E.direction = randDirs[random(1,#randDirs)]
							EnemyMovementHandlers[E.direction](name)
							return
						end
					--quad 3
					elseif distX >= 0 and distY <= 0 then
						if E.viableDirs.left then tinsert(randDirs,"left") end
						if E.viableDirs.down then tinsert(randDirs,"down") end
						if #randDirs > 0 then
							E.direction = randDirs[random(1,#randDirs)]
							EnemyMovementHandlers[E.direction](name)
							return
						end
					--quad 4
					elseif distX <= 0 and distY <= 0 then
						if E.viableDirs.right then tinsert(randDirs,"right") end
						if E.viableDirs.down then tinsert(randDirs,"down") end
						if #randDirs > 0 then
							E.direction = randDirs[random(1,#randDirs)]
							EnemyMovementHandlers[E.direction](name)
							return
						end
					end
					
					--move at random if none of the above conditions are met
					wipe(randDirs)
					for k,v in pairs(E.viableDirs) do if v then tinsert(randDirs,k) end end
					E.direction = randDirs[random(1,#randDirs)]
					EnemyMovementHandlers[E.direction](name)
					return
				else	--non-aggressive, move at random direction
					wipe(randDirs)
					for k,v in pairs(E.viableDirs) do if v then tinsert(randDirs,k) end end
					E.direction = randDirs[random(1,#randDirs)]
					EnemyMovementHandlers[E.direction](name)
					return
				end
					
			end
		end)
	end
	
	E = Enemies[name]
	E.viableDirs = {
		["right"] = false,
		["left"] = false,
		["up"] = false,
		["down"] = false,
	}
	local randDirection = random(1,4)
	if randDirection == 1 then E.direction = "right"
		elseif randDirection == 2 then E.direction = "up"
		elseif randDirection == 3 then E.direction = "left"
		elseif randDirection == 4 then E.direction = "down"
	end
	E.tslu = 0
	E.frame:Show()
	local framestartx,framestarty = PacCraftGameBoard:CellToCoords(PacCraftGameBoard.paths.enemyEntry)
	E.frame:SetPoint("TOPLEFT",PacCraftGameBoard,"TOPLEFT",framestartx,framestarty)
	E.xOffset = E.frame:GetLeft() - PacCraftGameBoard:GetLeft()
	E.yOffset = E.frame:GetTop() - PacCraftGameBoard:GetTop()
	E.cell = GetEnemyPieceCell(name)
	E.isFeared = false
end

function PacCraftGameBoard:CellToCoords(cell)	--returns x,y coords to for a cell (relative PacCraftGameBoard's topleft corner x,y) 
	return (cell % self.paths.columns) * self.paths.length, floor(cell / self.paths.columns) * -self.paths.length	
end

function MakePieceExist(parent,playerName,x,y)
	
	if type(x) ~= "number" or x == nil then
		x,y = parent:CellToCoords(parent.paths.playerEntry)
	end
	if type(y) ~= "number" or y == nil then
		x,y = parent:CellToCoords(parent.paths.playerEntry)
	end
	
	if not Players[playerName] then
		Players[playerName] = {}
		Players[playerName].frame = CreateFrame("frame","PacCraftPlayer_"..player,PacCraftGameBoard,"PacCraft_PlayerTemplate")
		Players[playerName].frame:SetPoint("TOPLEFT",PacCraftGameBoard,"TOPLEFT",x,y)
		Players[playerName].frame:SetToplevel(true)
		Players[playerName].frame.texture = _G[Players[playerName].frame:GetName().."_BGTexture"]
		Players[playerName].lives = 3
	end
end

function PacCraftGameBoard:ProcessAddonMessage(...)
	local prefix, msg, _, sender = select(1, ...)
	
	if prefix ~= "$pac" then return end
	--print(sender,msg)
	if sender == player then return end
	
	--if sender not in party then return
	if strsub(msg,1,1) == "!" then	--received an update msg

		local x, _, y = string.match(msg,"(%d+)(%/)(%d+)")	--coords of the topleft point of the sender's piece
		--print(msg,x,y)
		MakePieceExist(self,sender,x,-y)
		Players[sender].frame:SetPoint("TOPLEFT",self,"TOPLEFT",x,-y)
		
		
	end
	
	
end

function MapContainsCell(Paths,cell)	--returns true if [cell] is part of [Paths]
	if type(cell) ~= "number" then return false end
	if cell < 0 then return false end
	for k,v in pairs(Paths) do
		if type(k) == "number" then
			if v == cell then return true end
		end
	end
	return false
end

function GetViableDirections(Paths,startCell)
	--returns bools: up, down, left, right;
	if type(startCell) ~= "number" then return false end
	if startCell < 0 then return false end
	if not MapContainsCell(Paths,startCell) then return false end		--cell need to be in [Paths]
	local up, down, left, right = false, false, false, false

	up 		= 	MapContainsCell(Paths,startCell - Paths.columns)
	down 	= 	MapContainsCell(Paths,startCell + Paths.columns)
	left 	= 	(	(MapContainsCell(Paths,startCell - 1)) and (startCell % Paths.columns ~= 0)	)
	right 	= 	(	(MapContainsCell(Paths,startCell + 1)) and (startCell % Paths.columns ~= Paths.columns - 1)	)

	return up, down, left, right
end

function PacCraftGameBoard:SetPaths(Paths)
	if type(Paths) ~= "table" then print(addonTag,"Error in PacCraftGameBoard:CreatePaths(Paths) - \"Paths\" is invalid.  Cannot draw map."); return end
	if type(Paths.length) ~= "number" or type(Paths.columns) ~= "number" or type(Paths.rows) ~= "number" then
		print(addonTag,"Error in PacCraftGameBoard:CreatePaths(Paths) - One or more properties in Paths is invalid.  Cannot draw map.")
		return
	end
	local parent = self
	parent.paths = Paths
	parent:SetHeight(Paths.length * Paths.rows)
	parent:SetWidth(Paths.length * Paths.columns)
	parent:ResetMap()

	
	for k,v in pairs(Paths) do
		if type(k) == "number" then
			
			local key = tostring(v)	--cell number
			local frame = CreateFrame("Frame","PacPath"..tostring(v),parent,"PacCraft_PathFrameTemplate")
		
			frame:SetPoint("TOPLEFT",parent,"TOPLEFT",
				(Paths.length * (v % Paths.columns)),
				-(Paths.length * (floor(v / Paths.columns))))
			frame:SetPoint("BOTTOMRIGHT",parent,"TOPLEFT",
				(Paths.length * ((v % Paths.columns) + 1)),
				-(Paths.length * (floor(v / Paths.columns) + 1)))
			frame:Show()
			
			local x,y = frame:GetCenter()			
			--caching these values will save us lots of function calls later.  also, the game frame cannot be moved now or this data will be wrong
			PATHS[key] = {}
			PATHS[key].frame = frame
			PATHS[key].x = RoundRealToInt(x)						--Center x coord (number *rounded)
			PATHS[key].y = RoundRealToInt(y)						--Center y coord (number *rounded)
			PATHS[key].top = PATHS[key].frame:GetTop()			--top coord (number)
			PATHS[key].bottom = PATHS[key].frame:GetBottom()		--bottom coord (number)
			PATHS[key].left = PATHS[key].frame:GetLeft()			--
			PATHS[key].right = PATHS[key].frame:GetRight()		--
			PATHS[key].cell = v									--cell number (string)
			PATHS[key].UP, PATHS[key].DOWN, PATHS[key].LEFT, PATHS[key].RIGHT = GetViableDirections(Paths,v)		--booleans
			PATHS[key].hasPellet = false							--currently holding a pellet (boolean)
			
		end
	end
	
	if Paths.enemyHolding ~= nil then
		if not _G["PacHoldingCell"..tostring(Paths.enemyHolding)] then
			CreateFrame("Frame","PacHoldingCell"..tostring(Paths.enemyHolding),parent,"PacCraft_PathFrameTemplate")
		end
		local topLeftx, topLefty =  Paths.length * ((Paths.enemyHolding % Paths.columns)), Paths.length * (floor(Paths.enemyHolding / Paths.columns))
		local bottomRightx, bottomRighty = Paths.length * ((Paths.enemyHolding % Paths.columns) + 1), Paths.length * (floor(Paths.enemyHolding / Paths.columns) + 1)
		_G["PacHoldingCell"..tostring(Paths.enemyHolding)]:SetPoint("TOPLEFT",parent,"TOPLEFT",topLeftx,-topLefty)
		_G["PacHoldingCell"..tostring(Paths.enemyHolding)]:SetPoint("BOTTOMRIGHT",parent,"TOPLEFT",bottomRightx,-bottomRighty)
		_G["PacHoldingCell"..tostring(Paths.enemyHolding)]:Hide()
		_G["PacHoldingCell"..tostring(Paths.enemyHolding).."_BGTexture"]:SetTexture(1,0,1,1)
	end
	
	GameBoardTop,GameBoardBottom,GameBoardLeft,GameBoardRight = PacCraftGameBoard:GetTop(), PacCraftGameBoard:GetBottom(), PacCraftGameBoard:GetLeft(), PacCraftGameBoard:GetRight()
	self:SetBalls(Paths)
	CreatePlayerObject(PLAYER,nil)
end

function PacCraftGameBoard:SetBalls(Paths)
	local parent = self
	for k,v in pairs(Paths) do
		if type(k) == "number" then	--by design, v will also be a number
			if v ~= Paths.playerEntry and v ~= Paths.enemyHolding then
				if not tblContains(Pellets,_G["PacPellet"..tostring(v)]) then
					CreateFrame("Frame","PacPellet"..tostring(v),parent,"PacCraft_PelletTemplate")
				end
				tinsert(Pellets,_G["PacPellet"..tostring(v)])
				_G["PacPellet"..tostring(v)]:SetWidth(5 * (Paths.length/20))
				_G["PacPellet"..tostring(v)]:SetHeight(5 * (Paths.length/20))
				_G["PacPellet"..tostring(v)]:SetPoint("CENTER",_G["PacPath"..v],"CENTER")
				_G["PacPellet"..tostring(v).."_BGTexture"]:SetTexture("Interface\\AddOns\\MoosePacCraft\\pacsprites\\pellet")
				_G["PacPellet"..tostring(v)]:Show()
				
				PATHS[tostring(v)].hasPellet = true
			end
		end
	end
end

function PacCraftGameBoard_OnUpdate(self,elapsed)
	self.TimeSinceLastUpdate = self.TimeSinceLastUpdate + elapsed
	while self.TimeSinceLastUpdate >= ONUPDATE_SPEED do
		self:GameLoop()
		self.TimeSinceLastUpdate = self.TimeSinceLastUpdate - ONUPDATE_SPEED
	end
end

function GetPathCell(frame)
	if not frame then return nil end
	local cell = gsub(frame:GetName(),"PacPath","")
	return tonumber(cell)
end

function GetEnemyPieceCell(name)		--returns STRING, cell number that 'Enemies[name]' coords are in
	if not name then return nil end
	Enemies[name].CenterX, Enemies[name].CenterY = Enemies[name].frame:GetCenter()
	return tostring(floor(abs(GameBoardLeft - Enemies[name].CenterX) / PacCraftGameBoard.paths.length) + (floor(abs(GameBoardTop - Enemies[name].CenterY) / PacCraftGameBoard.paths.length) * PacCraftGameBoard.paths.columns))
end

function GetPieceCell(piece)		--returns STRING, cell number that 'piece' coords are in
	if not piece then return nil end
	piece.CenterX, piece.CenterY = piece.frame:GetCenter()
	return tostring(floor(abs(GameBoardLeft - piece.CenterX) / PacCraftGameBoard.paths.length) + (floor(abs(GameBoardTop - piece.CenterY) / PacCraftGameBoard.paths.length) * PacCraftGameBoard.paths.columns))
end

function PacCraftGameBoard:GameLoop()


	for k,player in pairs(Players) do
	
		--check collision with enemies (center points are within 15 pixels) using the distance formula
		for enemyK,enemyV in pairs(Enemies) do		
			if sqrt((player.CenterX - enemyV.CenterX) * (player.CenterX - enemyV.CenterX) + (player.CenterY - enemyV.CenterY) * (player.CenterY - enemyV.CenterY))
			<= 15 * (self.paths.length / 20) then	--distance scales with map scale
				--totally touching this ghosty's titties
				
				-- -1 life for this player; reset the player and ghosties (not pellets!)
				--game over if that was last life, return to menu
				
				break
			end
			
		end
		
		--player collision with pellets	
		if PATHS[player.cell].hasPellet == true then
			
			if sqrt((player.CenterX - PATHS[player.cell].x) * (player.CenterX - PATHS[player.cell].x) + (player.CenterY - PATHS[player.cell].y) * (player.CenterY - PATHS[player.cell].y))
			<= 8 * (self.paths.length / 20) then
				--totally touching this pellet's titties
				--check if that was the last pellet on the board 
					--if so, do a little victory stuffs and move to the next level, increase ghosty speed by a little and decrease the duration they remain feared
				
				
				-- +10 to score
				_G["PacPellet"..(player.cell)]:Hide()
				PATHS[player.cell].hasPellet = false
				
				
				
			end
			
			
		end

		
		
	end
	

	
end

function SendPacPlayerUpdate()
	

	if inParty then
		-- "!" in the beginning means it's an update message
		if not LastUpdatePositions[player] then LastUpdatePositions[player] = {["x"]=0,["y"]=0,} end
		local msg = ""
		local msgX = floor(Players[player].frame:GetLeft() - Players[player].frame:GetParent():GetLeft())
		local msgY = floor(Players[player].frame:GetParent():GetTop() - Players[player].frame:GetTop())
		if msgX ~= LastUpdatePositions[player].x or msgY ~= LastUpdatePositions[player].y then
			msg = "!["..tostring(msgX).."/"..tostring(msgY).."]"
			LastUpdatePositions[player] = {
				["x"] = floor(Players[player].frame:GetLeft() - Players[player].frame:GetParent():GetLeft()),
				["y"] = floor(Players[player].frame:GetParent():GetTop() - Players[player].frame:GetTop()),
			}
		end
		if msg ~= "" then
			SendAddonMessage("$pac", msg, inParty)
		end

	end
	
end



